/*
** Aminet Download Utility
**
** Copyright (C) 1997 Mark Rigby-Jones
** mrj@ox.compsoc.org.uk <*> http://www.ox.compsoc.org.uk/~mrj/
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** If you do not have a copy of the GNU General Public License then
** you can get one by writing to the Free Software Foundation, Inc.,
** 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdlib.h>
#include <stdio.h>
#include <strings.h>

#define OWNER      "Oxford University Computer Society"
#define OWNER_URL  "/"
#define OWNER_MAIL "webmaster@ox.compsoc.org.uk"
#define IMAGE      "/logos/aminet.gif"

char* query;
char* dir;

void aminet_link(char* server, char* desc)
{
  char *files;
  char *file;
  char *change;
  char readme[80];

  files = strdup(query);

  printf("<h2 align=center>%s</h2>\n<p align=center>", desc);

  if (files[0] == 0) {

    printf("<a href=\"ftp://%s/pub/aminet/%s/\">ftp://%s/pub/aminet/%s/</a></p>\n", server, dir, server, dir);

  } else {

    while (files != NULL) {
      file = strsep(&files, "&");
      strcpy(readme, file);
      change = strchr(readme, '.');
      if (change != NULL) {
	strcpy(change, ".readme");
	printf("<a href=\"ftp://%s/pub/aminet/%s/%s\">ftp://%s/pub/aminet/%s/%s</a> [<a href=\"ftp://%s/pub/aminet/%s/%s\">readme</a>]", server, dir, file, server, dir, file, server, dir, readme);
	if (files == NULL) {
	  printf("</p>\n");
	} else {
	  printf("<br>\n");
	}
      }
    }
  }
  free(files);
}

void main()
{
  char* change;

  if ((query = getenv("QUERY_STRING")) == NULL) {
    printf("Content-type: text/html\n\n<html>\n<head>\n<title>Aminet Error</title>\n</head>\n<body>\n<h1>Aminet Error!</h1>\nThis cgi-binary was incorrectly called - no arguments were given.\n</body>\n</html>\n");
    exit(1);
  }
  if (strchr(query, '&') == NULL) {
    strcat(query, "&");
  }
  dir = strsep(&query, "&");
  change = strchr(dir, '.');
  if (change == NULL) {
    exit(1);
  }
  change[0] = '/';

  printf("Content-type: text/html\n\n<html>\n<head>\n<link rev=made href=\"mailto:%s\">\n<title>Aminet Download</title>\n</head>\n<body bgcolor=#FFFFFF>\n<h1 align=center><img src=\"%s\" width=84 height=84><br>Aminet Download</h1>\n<p align=center>This page will allow you to download the requested file(s) from any of the full aminet mirrors. Pick the site which is closest to you. You may need to shift-click on the links to force your browser to download the file properly.</p>\n<hr size=4>\n", OWNER_MAIL, IMAGE);

  aminet_link("ftp.wustl.edu","Washington University in St.Louis (USA)");
  aminet_link("src.doc.ic.ac.uk","SunSITE, Imperial College (UK)");
  aminet_link("ftp.livewire.com.au","Livewire (Australia)");
  aminet_link("ftp.sunet.se","Swedish University Network");
  aminet_link("ftp.uni-paderborn.de","Universit&auml;t-GH Paderborn (Germany)");
  aminet_link("ftp.unina.it","Universita' degli Studi di Napoli (Italy)");
  aminet_link("vienna.aminet.or.at","Vienna (Austria)");

  printf("<hr size=4>\n<address>\n<p align=center>&copy;1997 <a href=\"%s\">%s</a><br>\n<a href=\"mailto:%s\">%s</a></p>\n</address>\n</body>\n</html>\n", OWNER_URL, OWNER, OWNER_MAIL, OWNER_MAIL);
}
